=== external/+Clipper/CMakeLists.txt ===
require_dependency(Boost)

rp_add_cmake_project(Clipper
    GIT_REPOSITORY      https://github.com/tamasmeszaros/libpolyclipping.git
)
