=== external/+NLopt/CMakeLists.txt ===
rp_add_cmake_project(NLopt
  GIT_REPOSITORY      https://github.com/stevengj/nlopt.git
  GIT_TAG             v2.6.1
  CMAKE_ARGS
    -DNLOPT_PYTHON:BOOL=OFF
    -DNLOPT_OCTAVE:BOOL=OFF
    -DNLOPT_MATLAB:BOOL=OFF
    -DNLOPT_GUILE:BOOL=OFF
    -DNLOPT_SWIG:BOOL=OFF
    -DNLOPT_TESTS:BOOL=OFF
)
