## libnest2d 0.4-26-g4d6fb4d

=== debian/changelog ===
libnest2d (0.4-26-g4d6fb4d-2) unstable; urgency=medium

  * Multi-Arch: foreign.

 -- Christoph Berg <myon@debian.org>  Mon, 07 Dec 2020 13:40:24 +0100

libnest2d (0.4-26-g4d6fb4d-1) unstable; urgency=medium

  * Initial Debian release.
  * This package is needed by cura and pynest2d.

 -- Christoph Berg <myon@debian.org>  Thu, 26 Nov 2020 21:15:54 +0100
