=== debian/changelog ===
libnest2d (4.12.0-1) unstable; urgency=medium

  * New upstream version 4.12.0.

 -- Christoph Berg <myon@debian.org>  Mon, 17 Jan 2022 12:44:12 +0100
