=== debian/control ===
--- 
+++ 
@@ -18,8 +18,7 @@
 
 Package: libnest2d-dev
 Section: libdevel
-Architecture: all
-Multi-Arch: foreign
+Architecture: any
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
